/*
 This fabric creates actions object skeleton for passed constants and serializer.
 Useful to create all actions for ear just in one line.
 */
"use strict";

exports.__esModule = true;
function serializeFabric(serializer, payload) {
  return payload.map(serializer);
}

exports["default"] = function (_ref, serializer) {
  var ADD = _ref.ADD;
  var REMOVE = _ref.REMOVE;
  var MERGE = _ref.MERGE;

  var serialize = serializeFabric.bind(this, serializer);

  return {
    add: function add(payload) {
      var entities = serialize([].concat(payload));
      return {
        type: ADD,
        entities: entities
      };
    },

    remove: function remove(payload) {
      var entities = [].concat(payload);
      var ids = entities.map(function (m) {
        return m.id;
      });

      return {
        type: REMOVE,
        ids: ids
      };
    },

    merge: function merge(payload) {
      var entities = serialize([].concat(payload));
      return {
        type: MERGE,
        entities: entities
      };
    }
  };
};

module.exports = exports["default"];