'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.syncCollection = syncCollection;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _actionFabric = require('./action-fabric');

var _actionFabric2 = _interopRequireDefault(_actionFabric);

var _reducerFabric = require('./reducer-fabric');

var _reducerFabric2 = _interopRequireDefault(_reducerFabric);

var _earFabric = require('./ear-fabric');

var _earFabric2 = _interopRequireDefault(_earFabric);

var _redux = require('redux');

function buildConstants(collectionName) {
  var uppercasedCollectionName = collectionName.toUpperCase();

  return {
    ADD: 'ADD_' + uppercasedCollectionName,
    REMOVE: 'REMOVE_' + uppercasedCollectionName,
    MERGE: 'MERGE_' + uppercasedCollectionName
  };
}

function buildReducers(collectionsMap) {
  var defaultIndexMap = { fields: { byId: 'id' } };
  return Object.keys(collectionsMap).reduce(function (collector, collectionName) {
    collector[collectionName] = _reducerFabric2['default'](buildConstants(collectionName), defaultIndexMap);
    return collector;
  }, {});
}

function buildEars(collectionsMap, _ref) {
  var dispatch = _ref.dispatch;

  var defaultSerializer = function defaultSerializer(model) {
    return _extends({}, model.toJSON(), { __optimistic_id: model.cid });
  };

  Object.keys(collectionsMap).forEach(function (collectionName) {
    var rawActions = _actionFabric2['default'](buildConstants(collectionName), defaultSerializer);
    _earFabric2['default'](collectionsMap[collectionName], rawActions, dispatch);
  });
}

function syncCollection(collectionsMap, store) {
  var reducers = buildReducers(collectionsMap);
  store.replaceReducer(_redux.combineReducers(reducers));
  buildEars(collectionsMap, store);
}