'use strict';

exports.__esModule = true;
exports.buildIndex = buildIndex;
exports.buildRelation = buildRelation;
exports.addEntities = addEntities;
exports.removeEntities = removeEntities;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function buildIndex(entities, field) {
  return entities.reduce(function (acc, entity) {
    return (acc[entity[field]] = entity, acc);
  }, {});
}

function buildRelation(entities, field) {
  return _lodash2['default'].groupBy(entities, field);
}

function addEntities(currentEntities, newEntities) {
  return [].concat(currentEntities, newEntities);
}

function removeEntities(currentEntities, removedIds) {
  var ids = _lodash2['default'].compact(_lodash2['default'].flatten(removedIds));
  return currentEntities.filter(function (entity) {
    return ids.indexOf(entity.id) < 0 && ids.indexOf(entity.__optimistic_id) < 0;
  });
}